Subject: Re: bug#45818: 28.0.50; Test solar-sunrise-sunset fails
From: Mattias Engdegård <[email-masked]>
To: "Basil L. Contovounesios" <[email-masked]>
Cc: [email-masked]
Date: Tue, 12 Jan 2021 22:02:15 +0100
List-Id: <debbugs-submit.debbugs.gnu.org>

12 jan. 2021 kl. 21.06 skrev Basil L. Contovounesios <[email-masked]>:

> So I'm guessing dst-adjust-time adjusts for DST in my locale (based on
> some cache), but not yours?  The following change lets the test succeed
> for me:

Thank you, and I agree that it's probably the pragmatic choice. Much as I would have liked to track down and explain the exact reason for the observed phenomenon, I gave up and pushed your suggested patch.

If I would hazard a guess, it's related to the fact that Ireland uses daylight saving in winter (with opposite adjustment) rather than in summer; this may trigger a daylight-saving adjustment for the dates in question (late December). The fact that IST is used for both Irish and Indian time may be significant or a mere coincidence; it certainly didn't help matters.

Date and time calculations can be both infuriatingly and delightfully messy, but in this case the code didn't really help either, with way too many implicit input parameters -- global variables, caches, system settings, time-zone files, and so on. Not something to make a test writer happy!

Thanks again for the report, and for persevering!